<?php
/* Autor...:  */
/* Esquema.: PR_Grupo.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Metodos de acceso a los campos de la tabla PR_Grupo */
abstract class BasePR_GrupoBN
{
    /* Campos de la tabla */
    private $s_IdPrGrupo;    // IdPrGrupo: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_IdPrTipoId;    // IdPrTipoId: ( no definido )
    private $d_FechaInicio;    // FechaInicio: ( no definido )
    private $d_FechaExpiracion;    // FechaExpiracion: ( no definido )
    private $s_DescripcionPromo;    // DescripcionPromo: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $i_IdLinea;    // IdLinea: ( no definido )
    private $i_IdFamilia;    // IdFamilia: ( no definido )
    private $s_Valor;    // Valor: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo IdPrGrupo */
    public function setIdPrGrupo( $s_IdPrGrupo )
    {
        $this->s_IdPrGrupo = $s_IdPrGrupo;
    }

    /* Obtiene el valor del campo IdPrGrupo */
    public function getIdPrGrupo()
    {
        return $this->s_IdPrGrupo;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdPrTipoId */
    public function setIdPrTipoId( $s_IdPrTipoId )
    {
        $this->s_IdPrTipoId = $s_IdPrTipoId;
    }

    /* Obtiene el valor del campo IdPrTipoId */
    public function getIdPrTipoId()
    {
        return $this->s_IdPrTipoId;
    }

    /* Establece el valor del campo FechaInicio */
    public function setFechaInicio( $d_FechaInicio )
    {
        $this->d_FechaInicio = $d_FechaInicio;
    }

    /* Obtiene el valor del campo FechaInicio */
    public function getFechaInicio()
    {
        return $this->d_FechaInicio;
    }

    /* Establece el valor del campo FechaExpiracion */
    public function setFechaExpiracion( $d_FechaExpiracion )
    {
        $this->d_FechaExpiracion = $d_FechaExpiracion;
    }

    /* Obtiene el valor del campo FechaExpiracion */
    public function getFechaExpiracion()
    {
        return $this->d_FechaExpiracion;
    }

    /* Establece el valor del campo DescripcionPromo */
    public function setDescripcionPromo( $s_DescripcionPromo )
    {
        $this->s_DescripcionPromo = $s_DescripcionPromo;
    }

    /* Obtiene el valor del campo DescripcionPromo */
    public function getDescripcionPromo()
    {
        return $this->s_DescripcionPromo;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo IdLinea */
    public function setIdLinea( $i_IdLinea )
    {
        $this->i_IdLinea = $i_IdLinea;
    }

    /* Obtiene el valor del campo IdLinea */
    public function getIdLinea()
    {
        return $this->i_IdLinea;
    }

    /* Establece el valor del campo IdFamilia */
    public function setIdFamilia( $i_IdFamilia )
    {
        $this->i_IdFamilia = $i_IdFamilia;
    }

    /* Obtiene el valor del campo IdFamilia */
    public function getIdFamilia()
    {
        return $this->i_IdFamilia;
    }

    /* Establece el valor del campo Valor */
    public function setValor( $s_Valor )
    {
        $this->s_Valor = $s_Valor;
    }

    /* Obtiene el valor del campo Valor */
    public function getValor()
    {
        return $this->s_Valor;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdPrGrupo' => $this->getIdPrGrupo(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdPrTipoId' => $this->getIdPrTipoId(),
            'FechaInicio' => $this->getFechaInicio(),
            'FechaExpiracion' => $this->getFechaExpiracion(),
            'DescripcionPromo' => $this->getDescripcionPromo(),
            'Estado' => $this->getEstado(),
            'IdLinea' => $this->getIdLinea(),
            'IdFamilia' => $this->getIdFamilia(),
            'Valor' => $this->getValor(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto PR_GrupoBN desde un RecordSet */
    public static function retrieveByRs( $o_PR_GrupoRs )
    {
        $o_PR_GrupoBN = new PR_GrupoBN();
        $o_PR_GrupoBN->setIdPrGrupo( $o_PR_GrupoRs[ "IdPrGrupo" ] );
        $o_PR_GrupoBN->setIdCompania( ( integer ) $o_PR_GrupoRs[ "IdCompania" ] );
        $o_PR_GrupoBN->setIdSucursal( ( integer ) $o_PR_GrupoRs[ "IdSucursal" ] );
        $o_PR_GrupoBN->setIdPrTipoId( $o_PR_GrupoRs[ "IdPrTipoId" ] );
        $o_PR_GrupoBN->setFechaInicio( utilTimestamp::getTimestamp( $o_PR_GrupoRs[ "FechaInicio" ], "Y-m-d H:i:s" ) );
        $o_PR_GrupoBN->setFechaExpiracion( utilTimestamp::getTimestamp( $o_PR_GrupoRs[ "FechaExpiracion" ], "Y-m-d H:i:s" ) );
        $o_PR_GrupoBN->setDescripcionPromo( $o_PR_GrupoRs[ "DescripcionPromo" ] );
        $o_PR_GrupoBN->setEstado( $o_PR_GrupoRs[ "Estado" ] );
        $o_PR_GrupoBN->setIdLinea( ( integer ) $o_PR_GrupoRs[ "IdLinea" ] );
        $o_PR_GrupoBN->setIdFamilia( ( integer ) $o_PR_GrupoRs[ "IdFamilia" ] );
        $o_PR_GrupoBN->setValor( $o_PR_GrupoRs[ "Valor" ] );
        $o_PR_GrupoBN->setUsuarioCreacion( $o_PR_GrupoRs[ "UsuarioCreacion" ] );
        $o_PR_GrupoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_PR_GrupoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_PR_GrupoBN->setUsuarioModificacion( $o_PR_GrupoRs[ "UsuarioModificacion" ] );
        $o_PR_GrupoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_PR_GrupoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_PR_GrupoBN;
    }
}
?>